// Copyright (C) 2007 Stanley Lee <stanigator@gmail.com>
// Acknowledgements to Jan Rudiger <jr@mbrains.de>

#include <common.h>
#include <initialization.h>
#include <adc.h>
#include <adcisr.h>

// would the following need to be in a constructor function?
int adc_value;				// change this to an array if there are more values
unsigned char adc_channel = 0;		// set initial adc_channel to 0
unsigned char adc_channel_limit = 0;	// set adc_channel to sample a/d channel 0 only


void adc_isr(void) interrupt 2
{
	static int adc_channel_limit = 0;		// limit on how many channels to read
	PORTCbits.RC1 = 1;

	// A/D converter ISR
	if (PIR1bits.ADIF)
	{
		adc_value = adc_read();		// change adc_value to array entry if required

		// set next channel
		if (adc_channel == adc_channel_limit) adc_channel = 0;
		else adc_channel++;
		adc_setchannel(adc_channel);

		// reset interrupt
		PIR1bits.ADIF = 0;
		adc_conv();			// restart sampling
	}
	PORTCbits.RC1 = 0;
}

unsigned int adcval(unsigned char channel_num)
{
	return adc_value;			// change to return adc_value[channel_num] if necessary
}
