// Copyright (C) 2007 Stanley Lee <stanigator@gmail.com>
// Acknowledgements to Jan Rudiger <jr@mbrains.de>

#include <common.h>
#include <initialization.h>
#include <adc.h>
#include <adcisr.h>

void init_cpu()
{
 	/* INT Osc with 8MHz */
 	OSCCON = 0x70;        /* 01110000 */
 	OSCTUNE = 0X0f;        /* oscillator tuning register at max frequency */
}

void adc_init()
{
	adc_open(ADC_CHN_1, ADC_FOSC_64, ADC_CFG_5A_0R, ADC_FRM_RJUST | ADC_INT_ON);
	// not sure if using channel select byte described in adc.h is correct

	// manual ADCON2 bit settings to get around sdcc adc lib bug
	ADCON2bits.ACQT0 = 1;
	ADCON2bits.ACQT1 = 1;
	ADCON2bits.ACQT2 = 1;

	TRISA = 0xff;	// input

	adc_conv();	// start initial sampling	
}
