// Copyright (C) 2007 Stanley Lee <stanigator@gmail.com>
// Acknowledgements to Jan Rudiger <jr@mbrains.de>

#include <common.h>
#include <initialization.h>
#include <adc.h>
#include <adcisr.h>

// Stack initialization in GPR
#pragma stack 0x200 0xff

// Set the __CONFIG words:
code char at __CONFIG1H _conf0 = _OSC_INTIO7_1H;
code char at __CONFIG2L _conf1 = _BOREN_OFF_2L & _PWRT_ON_2L;
code char at __CONFIG2H _conf2 = _WDT_DISABLED_CONTROLLED_2H;
code char at __CONFIG3H _conf3 = _MCLRE_MCLR_OFF_RE3_ON_3H;
code char at __CONFIG4L _conf4 = _LVP_OFF_4L & _XINST_OFF_4L & _DEBUG_OFF_4L;
code char at __CONFIG5L _conf5 = _CP_0_OFF_5L & _CP_1_OFF_5L;
code char at __CONFIG5H _conf6 = _CPD_OFF_5H & _CPB_OFF_5H;
code char at __CONFIG6L _conf7 = _WRT_0_OFF_6L & _WRT_1_OFF_6L;
code char at __CONFIG6H _conf8 = _WRTD_OFF_6H & _WRTB_OFF_6H & _WRTC_OFF_6H;
code char at __CONFIG7L _conf9 = _EBTR_0_OFF_7L & _EBTR_1_OFF_7L;
code char at __CONFIG7H _conf10 = _EBTRB_OFF_7H;

void delay(unsigned int dly)
{
	while (--dly > 0);
}

void main()
{
   init_cpu();
   adc_init();

   while(1)
   {
	PORTB = 0x00;		// first bit off
	delay(adcval(0));		//
	PORTB = 0X01;
	delay(adcval(0));	// let the spike be controlled by the a/d input value	
   }
}

